Save Agent Draft
curl --request PUT \
--url https://api.neuralfactory.ai/agents/{agent_id}/draft \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"spec": {
"title": "<string>",
"description": "<string>",
"knowledge_bases": [
"<string>"
],
"prompt": "<string>",
"model": "<string>",
"tags": [],
"allowed_groups": [],
"allowed_user_ids": [],
"visibility": "private",
"strict_mode": false,
"strict_mode_message": "",
"show_citations": false,
"core_tools": [
"web_search",
"knowledge_search",
"code_execution",
"file_editor",
"browser_automation",
"browser_control",
"image_generation"
],
"toolkits": [],
"workflows": [],
"agent_type": "agent",
"subagents": [
"<string>"
],
"workflow_config": {},
"skills": [],
"guardrails": {
"scope": "",
"cite_sources": true,
"hand_off": "<string>",
"approval_before": "<string>",
"language": "match the question",
"knowledge_only": false
},
"metadata": {},
"rationale": {}
},
"expected_revision": 123,
"design_history_append": [
{
"content": "<string>",
"at": "<string>",
"files": [
"<string>"
],
"kind": "status"
}
]
}
'import requests
url = "https://api.neuralfactory.ai/agents/{agent_id}/draft"
payload = {
"spec": {
"title": "<string>",
"description": "<string>",
"knowledge_bases": ["<string>"],
"prompt": "<string>",
"model": "<string>",
"tags": [],
"allowed_groups": [],
"allowed_user_ids": [],
"visibility": "private",
"strict_mode": False,
"strict_mode_message": "",
"show_citations": False,
"core_tools": ["web_search", "knowledge_search", "code_execution", "file_editor", "browser_automation", "browser_control", "image_generation"],
"toolkits": [],
"workflows": [],
"agent_type": "agent",
"subagents": ["<string>"],
"workflow_config": {},
"skills": [],
"guardrails": {
"scope": "",
"cite_sources": True,
"hand_off": "<string>",
"approval_before": "<string>",
"language": "match the question",
"knowledge_only": False
},
"metadata": {},
"rationale": {}
},
"expected_revision": 123,
"design_history_append": [
{
"content": "<string>",
"at": "<string>",
"files": ["<string>"],
"kind": "status"
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
spec: {
title: '<string>',
description: '<string>',
knowledge_bases: ['<string>'],
prompt: '<string>',
model: '<string>',
tags: [],
allowed_groups: [],
allowed_user_ids: [],
visibility: 'private',
strict_mode: false,
strict_mode_message: '',
show_citations: false,
core_tools: [
'web_search',
'knowledge_search',
'code_execution',
'file_editor',
'browser_automation',
'browser_control',
'image_generation'
],
toolkits: [],
workflows: [],
agent_type: 'agent',
subagents: ['<string>'],
workflow_config: {},
skills: [],
guardrails: {
scope: '',
cite_sources: true,
hand_off: '<string>',
approval_before: '<string>',
language: 'match the question',
knowledge_only: false
},
metadata: {},
rationale: {}
},
expected_revision: 123,
design_history_append: [{content: '<string>', at: '<string>', files: ['<string>'], kind: 'status'}]
})
};
fetch('https://api.neuralfactory.ai/agents/{agent_id}/draft', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.neuralfactory.ai/agents/{agent_id}/draft",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'spec' => [
'title' => '<string>',
'description' => '<string>',
'knowledge_bases' => [
'<string>'
],
'prompt' => '<string>',
'model' => '<string>',
'tags' => [
],
'allowed_groups' => [
],
'allowed_user_ids' => [
],
'visibility' => 'private',
'strict_mode' => false,
'strict_mode_message' => '',
'show_citations' => false,
'core_tools' => [
'web_search',
'knowledge_search',
'code_execution',
'file_editor',
'browser_automation',
'browser_control',
'image_generation'
],
'toolkits' => [
],
'workflows' => [
],
'agent_type' => 'agent',
'subagents' => [
'<string>'
],
'workflow_config' => [
],
'skills' => [
],
'guardrails' => [
'scope' => '',
'cite_sources' => true,
'hand_off' => '<string>',
'approval_before' => '<string>',
'language' => 'match the question',
'knowledge_only' => false
],
'metadata' => [
],
'rationale' => [
]
],
'expected_revision' => 123,
'design_history_append' => [
[
'content' => '<string>',
'at' => '<string>',
'files' => [
'<string>'
],
'kind' => 'status'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.neuralfactory.ai/agents/{agent_id}/draft"
payload := strings.NewReader("{\n \"spec\": {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"knowledge_bases\": [\n \"<string>\"\n ],\n \"prompt\": \"<string>\",\n \"model\": \"<string>\",\n \"tags\": [],\n \"allowed_groups\": [],\n \"allowed_user_ids\": [],\n \"visibility\": \"private\",\n \"strict_mode\": false,\n \"strict_mode_message\": \"\",\n \"show_citations\": false,\n \"core_tools\": [\n \"web_search\",\n \"knowledge_search\",\n \"code_execution\",\n \"file_editor\",\n \"browser_automation\",\n \"browser_control\",\n \"image_generation\"\n ],\n \"toolkits\": [],\n \"workflows\": [],\n \"agent_type\": \"agent\",\n \"subagents\": [\n \"<string>\"\n ],\n \"workflow_config\": {},\n \"skills\": [],\n \"guardrails\": {\n \"scope\": \"\",\n \"cite_sources\": true,\n \"hand_off\": \"<string>\",\n \"approval_before\": \"<string>\",\n \"language\": \"match the question\",\n \"knowledge_only\": false\n },\n \"metadata\": {},\n \"rationale\": {}\n },\n \"expected_revision\": 123,\n \"design_history_append\": [\n {\n \"content\": \"<string>\",\n \"at\": \"<string>\",\n \"files\": [\n \"<string>\"\n ],\n \"kind\": \"status\"\n }\n ]\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://api.neuralfactory.ai/agents/{agent_id}/draft")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"spec\": {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"knowledge_bases\": [\n \"<string>\"\n ],\n \"prompt\": \"<string>\",\n \"model\": \"<string>\",\n \"tags\": [],\n \"allowed_groups\": [],\n \"allowed_user_ids\": [],\n \"visibility\": \"private\",\n \"strict_mode\": false,\n \"strict_mode_message\": \"\",\n \"show_citations\": false,\n \"core_tools\": [\n \"web_search\",\n \"knowledge_search\",\n \"code_execution\",\n \"file_editor\",\n \"browser_automation\",\n \"browser_control\",\n \"image_generation\"\n ],\n \"toolkits\": [],\n \"workflows\": [],\n \"agent_type\": \"agent\",\n \"subagents\": [\n \"<string>\"\n ],\n \"workflow_config\": {},\n \"skills\": [],\n \"guardrails\": {\n \"scope\": \"\",\n \"cite_sources\": true,\n \"hand_off\": \"<string>\",\n \"approval_before\": \"<string>\",\n \"language\": \"match the question\",\n \"knowledge_only\": false\n },\n \"metadata\": {},\n \"rationale\": {}\n },\n \"expected_revision\": 123,\n \"design_history_append\": [\n {\n \"content\": \"<string>\",\n \"at\": \"<string>\",\n \"files\": [\n \"<string>\"\n ],\n \"kind\": \"status\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.neuralfactory.ai/agents/{agent_id}/draft")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"spec\": {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"knowledge_bases\": [\n \"<string>\"\n ],\n \"prompt\": \"<string>\",\n \"model\": \"<string>\",\n \"tags\": [],\n \"allowed_groups\": [],\n \"allowed_user_ids\": [],\n \"visibility\": \"private\",\n \"strict_mode\": false,\n \"strict_mode_message\": \"\",\n \"show_citations\": false,\n \"core_tools\": [\n \"web_search\",\n \"knowledge_search\",\n \"code_execution\",\n \"file_editor\",\n \"browser_automation\",\n \"browser_control\",\n \"image_generation\"\n ],\n \"toolkits\": [],\n \"workflows\": [],\n \"agent_type\": \"agent\",\n \"subagents\": [\n \"<string>\"\n ],\n \"workflow_config\": {},\n \"skills\": [],\n \"guardrails\": {\n \"scope\": \"\",\n \"cite_sources\": true,\n \"hand_off\": \"<string>\",\n \"approval_before\": \"<string>\",\n \"language\": \"match the question\",\n \"knowledge_only\": false\n },\n \"metadata\": {},\n \"rationale\": {}\n },\n \"expected_revision\": 123,\n \"design_history_append\": [\n {\n \"content\": \"<string>\",\n \"at\": \"<string>\",\n \"files\": [\n \"<string>\"\n ],\n \"kind\": \"status\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"draft": {
"spec": {
"title": "<string>",
"description": "<string>",
"knowledge_bases": [
"<string>"
],
"prompt": "<string>",
"model": "<string>",
"tags": [],
"allowed_groups": [],
"allowed_user_ids": [],
"visibility": "private",
"strict_mode": false,
"strict_mode_message": "",
"show_citations": false,
"core_tools": [
"web_search",
"knowledge_search",
"code_execution",
"file_editor",
"browser_automation",
"browser_control",
"image_generation"
],
"toolkits": [],
"workflows": [],
"agent_type": "agent",
"subagents": [
"<string>"
],
"workflow_config": {},
"skills": [],
"guardrails": {
"scope": "",
"cite_sources": true,
"hand_off": "<string>",
"approval_before": "<string>",
"language": "match the question",
"knowledge_only": false
},
"metadata": {},
"rationale": {}
},
"revision": 123,
"updated_at": "2023-11-07T05:31:56Z",
"updated_by": "<string>"
},
"checks": [
{
"id": "<string>",
"severity": "warn",
"title": "<string>",
"detail": "",
"fix": {
"kind": "ask",
"arg": ""
}
}
]
}{
"detail": [
{
"loc": [
"<string>"
],
"msg": "<string>",
"type": "<string>",
"input": "<unknown>",
"ctx": {}
}
]
}Agents
Save Agent Draft
API key permission: Agents (Admin also opens it).
PUT
/
agents
/
{agent_id}
/
draft
Save Agent Draft
curl --request PUT \
--url https://api.neuralfactory.ai/agents/{agent_id}/draft \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"spec": {
"title": "<string>",
"description": "<string>",
"knowledge_bases": [
"<string>"
],
"prompt": "<string>",
"model": "<string>",
"tags": [],
"allowed_groups": [],
"allowed_user_ids": [],
"visibility": "private",
"strict_mode": false,
"strict_mode_message": "",
"show_citations": false,
"core_tools": [
"web_search",
"knowledge_search",
"code_execution",
"file_editor",
"browser_automation",
"browser_control",
"image_generation"
],
"toolkits": [],
"workflows": [],
"agent_type": "agent",
"subagents": [
"<string>"
],
"workflow_config": {},
"skills": [],
"guardrails": {
"scope": "",
"cite_sources": true,
"hand_off": "<string>",
"approval_before": "<string>",
"language": "match the question",
"knowledge_only": false
},
"metadata": {},
"rationale": {}
},
"expected_revision": 123,
"design_history_append": [
{
"content": "<string>",
"at": "<string>",
"files": [
"<string>"
],
"kind": "status"
}
]
}
'import requests
url = "https://api.neuralfactory.ai/agents/{agent_id}/draft"
payload = {
"spec": {
"title": "<string>",
"description": "<string>",
"knowledge_bases": ["<string>"],
"prompt": "<string>",
"model": "<string>",
"tags": [],
"allowed_groups": [],
"allowed_user_ids": [],
"visibility": "private",
"strict_mode": False,
"strict_mode_message": "",
"show_citations": False,
"core_tools": ["web_search", "knowledge_search", "code_execution", "file_editor", "browser_automation", "browser_control", "image_generation"],
"toolkits": [],
"workflows": [],
"agent_type": "agent",
"subagents": ["<string>"],
"workflow_config": {},
"skills": [],
"guardrails": {
"scope": "",
"cite_sources": True,
"hand_off": "<string>",
"approval_before": "<string>",
"language": "match the question",
"knowledge_only": False
},
"metadata": {},
"rationale": {}
},
"expected_revision": 123,
"design_history_append": [
{
"content": "<string>",
"at": "<string>",
"files": ["<string>"],
"kind": "status"
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
spec: {
title: '<string>',
description: '<string>',
knowledge_bases: ['<string>'],
prompt: '<string>',
model: '<string>',
tags: [],
allowed_groups: [],
allowed_user_ids: [],
visibility: 'private',
strict_mode: false,
strict_mode_message: '',
show_citations: false,
core_tools: [
'web_search',
'knowledge_search',
'code_execution',
'file_editor',
'browser_automation',
'browser_control',
'image_generation'
],
toolkits: [],
workflows: [],
agent_type: 'agent',
subagents: ['<string>'],
workflow_config: {},
skills: [],
guardrails: {
scope: '',
cite_sources: true,
hand_off: '<string>',
approval_before: '<string>',
language: 'match the question',
knowledge_only: false
},
metadata: {},
rationale: {}
},
expected_revision: 123,
design_history_append: [{content: '<string>', at: '<string>', files: ['<string>'], kind: 'status'}]
})
};
fetch('https://api.neuralfactory.ai/agents/{agent_id}/draft', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.neuralfactory.ai/agents/{agent_id}/draft",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'spec' => [
'title' => '<string>',
'description' => '<string>',
'knowledge_bases' => [
'<string>'
],
'prompt' => '<string>',
'model' => '<string>',
'tags' => [
],
'allowed_groups' => [
],
'allowed_user_ids' => [
],
'visibility' => 'private',
'strict_mode' => false,
'strict_mode_message' => '',
'show_citations' => false,
'core_tools' => [
'web_search',
'knowledge_search',
'code_execution',
'file_editor',
'browser_automation',
'browser_control',
'image_generation'
],
'toolkits' => [
],
'workflows' => [
],
'agent_type' => 'agent',
'subagents' => [
'<string>'
],
'workflow_config' => [
],
'skills' => [
],
'guardrails' => [
'scope' => '',
'cite_sources' => true,
'hand_off' => '<string>',
'approval_before' => '<string>',
'language' => 'match the question',
'knowledge_only' => false
],
'metadata' => [
],
'rationale' => [
]
],
'expected_revision' => 123,
'design_history_append' => [
[
'content' => '<string>',
'at' => '<string>',
'files' => [
'<string>'
],
'kind' => 'status'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.neuralfactory.ai/agents/{agent_id}/draft"
payload := strings.NewReader("{\n \"spec\": {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"knowledge_bases\": [\n \"<string>\"\n ],\n \"prompt\": \"<string>\",\n \"model\": \"<string>\",\n \"tags\": [],\n \"allowed_groups\": [],\n \"allowed_user_ids\": [],\n \"visibility\": \"private\",\n \"strict_mode\": false,\n \"strict_mode_message\": \"\",\n \"show_citations\": false,\n \"core_tools\": [\n \"web_search\",\n \"knowledge_search\",\n \"code_execution\",\n \"file_editor\",\n \"browser_automation\",\n \"browser_control\",\n \"image_generation\"\n ],\n \"toolkits\": [],\n \"workflows\": [],\n \"agent_type\": \"agent\",\n \"subagents\": [\n \"<string>\"\n ],\n \"workflow_config\": {},\n \"skills\": [],\n \"guardrails\": {\n \"scope\": \"\",\n \"cite_sources\": true,\n \"hand_off\": \"<string>\",\n \"approval_before\": \"<string>\",\n \"language\": \"match the question\",\n \"knowledge_only\": false\n },\n \"metadata\": {},\n \"rationale\": {}\n },\n \"expected_revision\": 123,\n \"design_history_append\": [\n {\n \"content\": \"<string>\",\n \"at\": \"<string>\",\n \"files\": [\n \"<string>\"\n ],\n \"kind\": \"status\"\n }\n ]\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://api.neuralfactory.ai/agents/{agent_id}/draft")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"spec\": {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"knowledge_bases\": [\n \"<string>\"\n ],\n \"prompt\": \"<string>\",\n \"model\": \"<string>\",\n \"tags\": [],\n \"allowed_groups\": [],\n \"allowed_user_ids\": [],\n \"visibility\": \"private\",\n \"strict_mode\": false,\n \"strict_mode_message\": \"\",\n \"show_citations\": false,\n \"core_tools\": [\n \"web_search\",\n \"knowledge_search\",\n \"code_execution\",\n \"file_editor\",\n \"browser_automation\",\n \"browser_control\",\n \"image_generation\"\n ],\n \"toolkits\": [],\n \"workflows\": [],\n \"agent_type\": \"agent\",\n \"subagents\": [\n \"<string>\"\n ],\n \"workflow_config\": {},\n \"skills\": [],\n \"guardrails\": {\n \"scope\": \"\",\n \"cite_sources\": true,\n \"hand_off\": \"<string>\",\n \"approval_before\": \"<string>\",\n \"language\": \"match the question\",\n \"knowledge_only\": false\n },\n \"metadata\": {},\n \"rationale\": {}\n },\n \"expected_revision\": 123,\n \"design_history_append\": [\n {\n \"content\": \"<string>\",\n \"at\": \"<string>\",\n \"files\": [\n \"<string>\"\n ],\n \"kind\": \"status\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.neuralfactory.ai/agents/{agent_id}/draft")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"spec\": {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"knowledge_bases\": [\n \"<string>\"\n ],\n \"prompt\": \"<string>\",\n \"model\": \"<string>\",\n \"tags\": [],\n \"allowed_groups\": [],\n \"allowed_user_ids\": [],\n \"visibility\": \"private\",\n \"strict_mode\": false,\n \"strict_mode_message\": \"\",\n \"show_citations\": false,\n \"core_tools\": [\n \"web_search\",\n \"knowledge_search\",\n \"code_execution\",\n \"file_editor\",\n \"browser_automation\",\n \"browser_control\",\n \"image_generation\"\n ],\n \"toolkits\": [],\n \"workflows\": [],\n \"agent_type\": \"agent\",\n \"subagents\": [\n \"<string>\"\n ],\n \"workflow_config\": {},\n \"skills\": [],\n \"guardrails\": {\n \"scope\": \"\",\n \"cite_sources\": true,\n \"hand_off\": \"<string>\",\n \"approval_before\": \"<string>\",\n \"language\": \"match the question\",\n \"knowledge_only\": false\n },\n \"metadata\": {},\n \"rationale\": {}\n },\n \"expected_revision\": 123,\n \"design_history_append\": [\n {\n \"content\": \"<string>\",\n \"at\": \"<string>\",\n \"files\": [\n \"<string>\"\n ],\n \"kind\": \"status\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"draft": {
"spec": {
"title": "<string>",
"description": "<string>",
"knowledge_bases": [
"<string>"
],
"prompt": "<string>",
"model": "<string>",
"tags": [],
"allowed_groups": [],
"allowed_user_ids": [],
"visibility": "private",
"strict_mode": false,
"strict_mode_message": "",
"show_citations": false,
"core_tools": [
"web_search",
"knowledge_search",
"code_execution",
"file_editor",
"browser_automation",
"browser_control",
"image_generation"
],
"toolkits": [],
"workflows": [],
"agent_type": "agent",
"subagents": [
"<string>"
],
"workflow_config": {},
"skills": [],
"guardrails": {
"scope": "",
"cite_sources": true,
"hand_off": "<string>",
"approval_before": "<string>",
"language": "match the question",
"knowledge_only": false
},
"metadata": {},
"rationale": {}
},
"revision": 123,
"updated_at": "2023-11-07T05:31:56Z",
"updated_by": "<string>"
},
"checks": [
{
"id": "<string>",
"severity": "warn",
"title": "<string>",
"detail": "",
"fix": {
"kind": "ask",
"arg": ""
}
}
]
}{
"detail": [
{
"loc": [
"<string>"
],
"msg": "<string>",
"type": "<string>",
"input": "<unknown>",
"ctx": {}
}
]
}Authorizations
Query Parameters
Body
application/json